import api.http.WebRequest;
import api.http.WebResponse;
import org.apache.commons.lang3.StringUtils;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	if (!StringUtils.equalsIgnoreCase(request.getMethod(), "GET")) {
		// Method Not Allowed
		response.setStatus(405);
		return;
	}

	def req = [
		"businessKey": WebAPI.getParameter("businessKey").defaultString(),
		"filename": WebAPI.getParameter("filename").defaultString(),
		"range": WebRequest.create(request).range
	];
	def isValid = {->
    	if (!req.businessKey) {
    		return false;
    	}

    	if (!req.filename) {
    		return false;
    	}

    	if (req.range && !req.range.isValid()) {
    		return false;
    	}

		return true;
	}();
	if (!isValid) {
		// Bad Request
		response.setStatus(400);
		return;
	}

	try {
		def r = repositorySession.resourceResolver.getResource("/var/approvals/" + req.businessKey + "/" + req.filename);

        WebResponse
            .create(response)
		    .setStatus(200)
		    .setAttachment(r.name)
		    .disableContentCache()
		    .setContentType(r.contentType)
		    .setCharacterEncoding(r.contentEncoding)
		    .setContentLength(r.contentLength)
		    .setETag(r.lastModified.time as String)
		    .writePartial(r.getContentAsStream(), req.range);
	} catch (Throwable ex) {
		response.sendError(500, ex.message);
		return;
	}
}();
