<html lang="ja">
	<head>
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1, user-scalable=no">
		<meta name="author" content="MintJams Inc.">
		<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.1/css/all.min.css">
		<link rel="stylesheet" href="style.css">
		<title>承認フォーム | ワークフローと意思決定の自動化</title>
	</head>
	<body>
		<div id="app" class="container p-4">
			<div class="h3 p-3 bg-primary text-white font-weight-bold">承認決定フォーム</div>
			<div class="mx-1 mt-2 font-weight-bold">({{businessKey}})</div>

			<div v-if="!result">
				<div class="mt-5 h4 font-weight-bold">申請者：</div>
				<div class="mt-2">{{bpm.task.variables.starter}}</div>
				<div class="mt-5 h4 font-weight-bold">申請書類を確認して承認してください。</div>
				<div class="mt-2">
					<table class="table table-bordered table-striped">
						<thead>
							<tr>
								<th class="text-left">ファイル<span class="d-none d-md-inline">名</span></th>
								<th class="text-center d-none d-md-table-cell">サイズ</th>
								<th class="text-center d-none d-md-table-cell">更新日時</th>
							</tr>
						</thead>
						<tbody>
							<tr v-for="(file, index) in files" :key="index">
								<th class="text-left">
									<div class="d-flex align-items-center">
										<i class="fas fa-file-alt mr-3 mb-0 h4"></i>
										<div>
											<div><a href="javascript:void(0)" v-on:click="downloadFile(file)">{{file.name}}</a></div>
											<div class="d-block d-md-none text-small font-weight-normal"><span class="mr-3">{{file.size}} bytes</span><span>{{new Date(file.modified).toLocaleString()}}</span></div>
										</div>
									</div>
								</th>
								<td class="text-center d-none d-md-table-cell">{{file.size}} bytes</td>
								<td class="text-center d-none d-md-table-cell">{{new Date(file.modified).toLocaleString()}}</td>
							</tr>
						</tbody>
					</table>
				</div>
				<div class="mt-2 d-flex justify-content-between">
					<button type="button" class="btn btn-danger" v-on:click="doReject"><i class="fas fa-times mr-2"></i>却下する</button>
					<button type="button" class="btn btn-success" v-on:click="doApprove"><i class="fas fa-check mr-2"></i>承認する</button>
				</div>
			</div>

			<div v-if="result">
				<div v-if="isApproved" class="mt-5 h4 font-weight-bold">承認しました。</div>
				<div v-if="isRejected" class="mt-5 h4 font-weight-bold">却下しました。</div>
				<div class="mt-2">
					<div>申請番号 (BusinessKey)：{{businessKey}}</div>
				</div>
				<div class="mt-2 d-flex justify-content-between">
					<button type="button" class="btn btn-primary" v-on:click="closeForm">閉じる</button>
				</div>
			</div>

			<div class="pt-5"><!-- spacer --></div>
		</div>

		<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
		<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/vue"></script>
		<script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
		<script>
			var onFormLoad = function(bpm) {
				new Vue({
					'el': '#app',
					data() {
						return {
							'bpm': bpm,
							'files': JSON.parse(bpm.task.variables.filesJson),
							'result': '',
							'businessKey': bpm.task.processInstance.businessKey,
							'stage': '<%= WebAPI.getParameter("stage").defaultString() %>'
						};
					},
					computed: {
						isApproved() {
							return (this.result == 'approved');
						},
						isRejected() {
							return (this.result == 'rejected');
						}
					},
					methods: {
						downloadFile(file) {
							location.href = "DownloadFile.groovy"
									+ "?businessKey=" + encodeURIComponent(this.businessKey)
									+ "&filename=" + encodeURIComponent(file.name);
						},
						doApprove() {
							let variables = {};
							variables['approved' + this.stage] = true;
							this.bpm.task.complete({
								'variables': variables
							}).then((result) => {
								if (result.isSuccess) {
									this.result = 'approved';
									return;
								}
							});
						},
						doReject() {
							let variables = {};
							variables['approved' + this.stage] = false;
							this.bpm.task.complete({
								'variables': variables
							}).then((result) => {
								if (result.isSuccess) {
									this.result = 'rejected';
									return;
								}
							});
						},
						closeForm() {
							this.bpm.closeForm();
						}
					}
				});
			};

			// preview
			if (location.href.indexOf('mx.preview') != -1) {
				onFormLoad({
					'task': {
						'processInstance': {
							'businessKey': 'approval-' + Date.now()
						},
						'variables': {
							'starter': 'username',
							'filesJson': JSON.stringify([
								{
									'name': 'file1.xlsx',
									'type': '',
									'size': 100,
									'modified': new Date().toISOString(),
									'data': ''
								}
							])
						}
					}
				});
			}
		</script>
	</body>
</html>
